// Code generated by github.com/atombender/go-jsonschema, DO NOT EDIT.

package payloads

import "fmt"
import "encoding/json"

type AreaResp struct {
	// Codes corresponds to the JSON schema field "codes".
	Codes []string `json:"codes"`

	// Name corresponds to the JSON schema field "name".
	Name string `json:"name"`

	// Region corresponds to the JSON schema field "region".
	Region string `json:"region"`

	// RegionCode corresponds to the JSON schema field "region_code".
	RegionCode string `json:"region_code"`
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *AreaResp) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if v, ok := raw["codes"]; !ok || v == nil {
		return fmt.Errorf("field codes: required")
	}
	if v, ok := raw["name"]; !ok || v == nil {
		return fmt.Errorf("field name: required")
	}
	if v, ok := raw["region"]; !ok || v == nil {
		return fmt.Errorf("field region: required")
	}
	if v, ok := raw["region_code"]; !ok || v == nil {
		return fmt.Errorf("field region_code: required")
	}
	type Plain AreaResp
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = AreaResp(plain)
	return nil
}

type IndustryResp struct {
	// Code corresponds to the JSON schema field "code".
	Code string `json:"code"`

	// Name corresponds to the JSON schema field "name".
	Name string `json:"name"`
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *IndustryResp) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if v, ok := raw["code"]; !ok || v == nil {
		return fmt.Errorf("field code: required")
	}
	if v, ok := raw["name"]; !ok || v == nil {
		return fmt.Errorf("field name: required")
	}
	type Plain IndustryResp
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = IndustryResp(plain)
	return nil
}

type Results struct {
	// Areas corresponds to the JSON schema field "areas".
	Areas []AreaResp `json:"areas"`

	// Industries corresponds to the JSON schema field "industries".
	Industries []IndustryResp `json:"industries"`
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *Results) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if v, ok := raw["areas"]; !ok || v == nil {
		return fmt.Errorf("field areas: required")
	}
	if v, ok := raw["industries"]; !ok || v == nil {
		return fmt.Errorf("field industries: required")
	}
	type Plain Results
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = Results(plain)
	return nil
}

type ScrubberSearchSchemaJson struct {
	// Query corresponds to the JSON schema field "query".
	Query string `json:"query"`

	// Results corresponds to the JSON schema field "results".
	Results Results `json:"results"`

	// Time corresponds to the JSON schema field "time".
	Time string `json:"time"`
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *ScrubberSearchSchemaJson) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if v, ok := raw["query"]; !ok || v == nil {
		return fmt.Errorf("field query: required")
	}
	if v, ok := raw["results"]; !ok || v == nil {
		return fmt.Errorf("field results: required")
	}
	if v, ok := raw["time"]; !ok || v == nil {
		return fmt.Errorf("field time: required")
	}
	type Plain ScrubberSearchSchemaJson
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = ScrubberSearchSchemaJson(plain)
	return nil
}
